(function(){
    'use strict';
    function setup() {
        var deltas = document.getElementsByClassName('delta');
        var installation = document.getElementsByClassName('install');
        var listTasks = document.getElementsByClassName('list-tasks');
        var details = document.getElementById('all-details');
        var startMagnoliaBtn = document.getElementById('buttonGo');
        var isStartMagnoliaBtnClicked = false;


        if ( listTasks.length > 0) {
            if (details) {
                details.addEventListener('click', switchAllDetails);
            }

            for (var i = 0; i < deltas.length; i++) {
                deltas[i].addEventListener('click', toggleArrow);
            }
        }

        if ( installation.length > 0 ) {
            setMessagesIcons();
        }

        if (!!document.getElementById('progress')) {
            setInterval(loadProgress, 500);
        }

        if (startMagnoliaBtn !== null ) {
            startMagnoliaBtn.addEventListener('click', function (e){
                if ( isStartMagnoliaBtnClicked === false ){
                    var startIcon = document.getElementsByClassName('icon icon-arrow-link')[0];
                    var startMagnoliaBtnText = document.getElementsByClassName('button-text')[0];
                    startMagnoliaBtn.classList.add('disableBtn');
                    startIcon.className = 'fa fa-refresh fa-spin';
                    startMagnoliaBtnText.textContent = 'Starting...';
                    isStartMagnoliaBtnClicked = true;
                } else {
                    e.preventDefault();
                }
            });
        }

        handleShader();

    }

    function loadProgress() {
        var xhttp = new XMLHttpRequest();
        var isInProgress = true;
        var status;

        xhttp.onreadystatechange = function() {
            if (this.readyState == 4 && this.status == 200) {
                document.getElementById("progress").innerHTML = this.response;
                setMessagesIcons( isInProgress );
                status = document.getElementById('status').dataset.status;

                if ( status !== "inProgress" ){
                    window.location.replace('${contextPath}${installerPath}/status');
                }
            }
        };
        xhttp.open("PUT", "${contextPath}${installerPath}/inProgressCall", true);
        xhttp.send();
    }

    function toggleOpen(el,icon,delta,module,closeAll){
        el.classList.remove('open');
        icon.classList.remove('icon-arrow2_n');
        icon.classList.add('icon-arrow2_s');
        delta.classList.remove('isOpen');
        if (closeAll) module.classList.remove('open');
    }

    function toggleClose(el,icon,delta,module){
        el.classList.add('open');
        icon.classList.add('icon-arrow2_n');
        icon.classList.remove('icon-arrow2_s');
        delta.classList.add('isOpen');
        module.classList.add('open');
    }

    function toggleArrow(evt){
        evt.preventDefault();
        var delta = this;
        var module = delta.parentElement;
        var icon = delta.getElementsByClassName('icon')[0];
        var condition = delta.getElementsByClassName('conditions')[0];
        var task = delta.getElementsByClassName('tasks')[0];

        function isOpen(item){
            return item.classList.contains('isOpen') ? item : false;
        }

        function toggle(el){
            var deltasInModule;
            var closeAll;
            var htmlCollectionInArray;
            var openedItems;

            if (el.classList.contains('open')) {
                deltasInModule = module.getElementsByClassName('delta');
                htmlCollectionInArray = [].slice.call(deltasInModule);
                openedItems = htmlCollectionInArray.filter(isOpen);
                closeAll = openedItems.length < 1;
                toggleOpen(el,icon,delta,module,closeAll);
            } else {
                toggleClose(el,icon,delta,module);
            }
        }

        toggle(condition);
        toggle(task);

    }

    function switchAllDetails(){
        var details = document.getElementById('all-details');
        var modules = document.getElementsByClassName('module');
        var els,elIcon,modulesArray,elsArray,delta;

        function toggleDetails(toggle, openAll){
            modulesArray = [].slice.call(modules);
            modulesArray.map(function(module){
                els = module.getElementsByTagName('ul');
                elsArray = [].slice.call(els);
                elsArray.map(function(el){
                    delta = el.parentElement;
                    elIcon = delta.getElementsByClassName('icon')[0];
                    if (toggle === 'open') {
                        toggleClose(el,elIcon,delta,module);
                    } else if (toggle === 'close') {
                        toggleOpen(el,elIcon,delta,module,openAll);
                    } else {
                        return false;
                    }
                });
            });
            details.classList.toggle('closed');
            details.classList.toggle('opened');
        }

        if (details.classList.contains('closed')) {
            toggleDetails('open',false);
            details.innerHTML = "<span class='icon icon-arrow2_n'></span>hide all details";

        } else if (details.classList.contains('opened')) {
            toggleDetails('close',true);
            details.innerHTML = "<span class='icon icon-arrow2_s'></span>show all details";
        }
    }


    function setMessagesIcons( isInProgress ){
        var modules = document.getElementsByClassName('module');

        function setIcon( parent, innerIcon, outerIcon, frontColor, backColor) {
            var spanOuter, spanInner, h3;

            spanOuter = document.createElement('span');
            spanOuter.className += 'icon ';
            spanOuter.className += outerIcon;
            spanOuter.className += ' outer ';
            spanOuter.className += backColor;

            spanInner = document.createElement('span');
            spanInner.className += "icon ";
            spanInner.className += innerIcon;
            spanInner.className += ' inner ';
            spanInner.className += frontColor;

            h3 = parent.getElementsByTagName('h3');
            parent.insertBefore(spanOuter, h3[0]);
            parent.insertBefore(spanInner, h3[0]);

            return false;
        }

        function existsIcon ( module ) {
            if ( module.classList.contains('error') || module.classList.contains('warning') ||module.classList.contains('info')) {
                return true;
            } else {
                return false;
            }
        }

        function setIcons(){
            var flag;
            for (var i = 0; i < modules.length; i++){
                if ( !existsIcon(modules[i])) {
                    flag = modules[i].getElementsByClassName('message')[0];
                    if ( flag.classList.contains('error')){
                        setIcon(modules[i],'icon-close','icon-shape-circle','msg-bkg-error','msg-err');
                        if (!isInProgress) modules[i].classList.add('error');
                    } else if ( flag.classList.contains('warning')){
                        setIcon(modules[i],'icon-warning-mark', 'icon-shape-circle','msg-bkg-grey','msg-wrn');
                        if (!isInProgress) modules[i].classList.add('warning');
                    } else if ( flag.classList.contains('info')){
                        setIcon(modules[i],'icon-info_mark', 'icon-shape-circle','msg-bkg-white','msg-inf');
                        if (!isInProgress) modules[i].classList.add('info');
                    } else if (flag.classList.contains('restartNeeded')) {
                        setIcon(modules[i],'icon-warning-mark', 'icon-shape-circle','msg-bkg-grey','msg-wrn');
                        modules[i].classList.add('restartNeeded');
                        if (!isInProgress) modules[i].classList.add('warning');
                        var restartInfo = document.createElement('p');
                        var restartInfoText = document.createTextNode('Restart Magnolia to conclude the installation of this module.');
                        restartInfo.appendChild(restartInfoText);
                        modules[i].appendChild(restartInfo);
                    } else {
                        return false;
                    }
                }
            }
        }
        setIcons();
    }

    function handleShader() {
        var shader = document.getElementById('shader');

        if (shader) {

            shader.className = window.scrollY > 20 ? "open" : '';

            window.addEventListener("scroll", function(){
                if ( window.scrollY > 20) {
                    shader.className = 'open';
                } else {
                    shader.className = '';
                }
            });
        }
    }

    window.onload = setup();
}());
